/*
 * Copyright (C) 2005 Benjamin Cutler
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "powrprof.h"
#include "ntstatus.h"
#include "wine/debug.h"

WINE_DEFAULT_DEBUG_CHANNEL(powrprof);

NTSTATUS WINAPI CallNtPowerInformation(
			POWER_INFORMATION_LEVEL InformationLevel, 
			PVOID lpInputBuffer, ULONG nInputBufferSize, 
			PVOID lpOutputBuffer, ULONG nOutputBufferSize) 
{
	FIXME("(%d %p %d %p %d) stub!\n", InformationLevel, lpInputBuffer, nInputBufferSize, lpOutputBuffer, nOutputBufferSize);
	SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
	return STATUS_ACCESS_DENIED;
}

BOOLEAN WINAPI CanUserWritePwrScheme(VOID)
{
	FIXME("stub!\n");
	SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
	return 0;
}

BOOLEAN WINAPI DeletePwrScheme(UINT uiIndex)
{
	FIXME("(%d) stub!\n", uiIndex);
	SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
	return 0;
}

BOOLEAN WINAPI EnumPwrSchemes(PWRSCHEMESENUMPROC lpfnPwrSchemesEnumProc, 
			LPARAM lParam)
{
	FIXME("(%p, %d) stub!\n", lpfnPwrSchemesEnumProc, lParam);
	SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
	return 0;
}

BOOLEAN WINAPI GetActivePwrScheme(PUINT puiID)
{
	FIXME("(%p) stub!\n", puiID);
	SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
	return 0;
}

BOOLEAN WINAPI GetCurrentPwrPolicies(
			PGLOBAL_POWER_POLICY pGlobalPowerPolicy, 
			PPOWER_POLICY pPowerPolicy)
{
	FIXME("(%p, %p) stub!\n", pGlobalPowerPolicy, pPowerPolicy);
	SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
	return 0;
}

BOOLEAN WINAPI GetPwrCapabilities(
			PSYSTEM_POWER_CAPABILITIES lpSystemPowerCapabilities)
{
	FIXME("(%p) stub!\n", lpSystemPowerCapabilities);
	SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
	return 0;
}

BOOLEAN WINAPI GetPwrDiskSpindownRange(PUINT RangeMax, PUINT RangeMin)
{
	FIXME("(%p, %p) stub!\n", RangeMax, RangeMin);
	SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
	return 0;
}

BOOLEAN WINAPI IsPwrHibernateAllowed(VOID)
{
	FIXME("stub!\n");
	SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
	return 0;
}

BOOLEAN WINAPI IsPwrShutdownAllowed(VOID)
{
	FIXME("stub!\n");
	SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
	return 0;
}

BOOLEAN WINAPI IsPwrSuspendAllowed(VOID)
{
	FIXME("stub!\n");
	SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
	return 0;
}

BOOLEAN WINAPI ReadGlobalPwrPolicy(PGLOBAL_POWER_POLICY pGlobalPowerPolicy)
{
	FIXME("(%p) stub!\n", pGlobalPowerPolicy);
	SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
	return 0;
}

BOOLEAN WINAPI ReadProcessorPwrScheme(UINT uiID, 
			PMACHINE_PROCESSOR_POWER_POLICY pMachineProcessorPowerPolicy)
{
	FIXME("(%d, %p) stub!\n", uiID, pMachineProcessorPowerPolicy);
	SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
	return 0;
}

BOOLEAN WINAPI ReadPwrScheme(UINT uiID,
			PPOWER_POLICY pPowerPolicy)
{
	FIXME("(%d, %p) stub!\n", uiID, pPowerPolicy);
	SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
	return 0;
}

BOOLEAN WINAPI SetActivePwrScheme(UINT uiID, 
			PGLOBAL_POWER_POLICY lpGlobalPowerPolicy, 
			PPOWER_POLICY lpPowerPolicy)
{
	FIXME("(%d, %p, %p) stub!\n", uiID, lpGlobalPowerPolicy, lpPowerPolicy);
	SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
	return 0;
}

BOOLEAN WINAPI SetSuspendState(BOOLEAN Hibernate, BOOLEAN ForceCritical, 
			BOOLEAN DisableWakeEvent)
{
	FIXME("(%d, %d, %d) stub!\n", Hibernate, ForceCritical, DisableWakeEvent);
	SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
	return 0;
}

BOOLEAN WINAPI WriteGlobalPwrPolicy(PGLOBAL_POWER_POLICY pGlobalPowerPolicy)
{
	FIXME("(%p) stub!\n", pGlobalPowerPolicy);
	SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
	return 0;
}

BOOLEAN WINAPI WriteProcessorPwrScheme(UINT ID, 
			PMACHINE_PROCESSOR_POWER_POLICY pMachineProcessorPowerPolicy)
{
	FIXME("(%d, %p) stub!\n", ID, pMachineProcessorPowerPolicy);
	SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
	return 0;
}

BOOLEAN WINAPI WritePwrScheme(PUINT puiID, LPWSTR lpszName, LPWSTR lpszDescription, 
			PPOWER_POLICY pPowerPolicy)
{
	FIXME("(%d, %s, %s, %p) stub!\n", puiID, lpszName, lpszDescription, pPowerPolicy);
	SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
	return 0;
}
